;   RoToR - a 128 bytes demo for ByteFall'99   ;      Tasm /m2 Rotor.asm
;      Coded by Basil (c)Z-corp. software      ;      Tlink /t Rotor.obj
;             2:5084/11.4@FidoNet              ;         102/93 bytes
.model tiny
.code
p386

        clean   equ

                org     100h
Rotor           proc    near

        ifdef   clean
                mov     si,offset Rotor
                push    0A000h
                pop     es
                fninit
                mov     ax,13h
        else
                les     dx,[bx]
                mov     al,13h
        endif
                int     10h
                fldz
main:
                mov     dx,3DAh
                in      al,dx
                and     al,8
                jz      main

                fisub   word ptr [si-(offset Rotor - offset step)]
                fld     st
                fsincos
                fimul   word ptr [si-(offset Rotor - offset hint1)]
                fistp   word ptr [si]
                fimul   word ptr [si-(offset Rotor - offset hint1)]
                fistp   word ptr [si+2]

                db      99h              ; cwd     ; xor dx,dx
                xor     bx,bx
                xor     di,di

                db      0B9h             ; mov     cx,...
hint1           dw      200              ; Fixed point base
yloop:
                push    bx dx
                mov     bp,320
xloop:
                add     dx,[si]
                add     bx,[si+2]
                mov     al,bh
                xor     al,dh

                db      4                ; add     al,...
hint2:          db      0

                jns     Color_Ok
                not     al
Color_Ok:
                shr     al,3
                add     al,16
                stosb
                dec     bp
                jnz     xloop

step            label   word ; dw 05B5Ah  = (3722*2*pi)-0.01571332242086676
                pop     dx bx

                add     bx,[si]
                sub     dx,[si+2]
                loop    yloop

                inc     byte ptr [si-(offset Rotor - offset hint2)]

                in      al,60h
        ifdef   clean
                cbw
                dec     ax
                jnz     main
        else
                das
                jp      main
        endif
                mov     al,3
                int     10h
                ret
Rotor           endp
                end     Rotor;128b for ByteFall'99 by BSL//ZcS
